
#define	_CRT_SECURE_NO_WARNINGS

#include <stdio.h>
#include <string.h>
#include <time.h>
#include <stdlib.h>
#include "Quiz.h"

/*	Ͽ   о quiz迭 ϴ Լ	*/
void ReadFileFix(Quiz* _pQuiz, char* _pFileName);

/*	Ͽ   о quiz迭 ϴ Լ	*/
void ReadFile(Quiz* _pQuiz, char* _pFileName);

/*	
	 Ͽ ҷ Ͱ quiz迭 Ǿ Ȯϴ Լ,
	   ϴ Լ ߿  ȴ.
*/
void DisplayQuiz(Quiz* _pQuiz, int _quizCount);

/*	 Ǫ Լ	*/
void GamePlay(Quiz* _pQuiz, const int _QuizNums);

int main(void)
{
	Quiz* quiz = NULL;	//	   迭
	int UserInput = 0;
	int QuizNums = 0;	//	 
	char buf[256];

	FILE* pFile = NULL;
	fopen_s(&pFile, "Quiz.txt", "r");

	while (!feof(pFile))
	{
		fgets(buf, 256, pFile);
		QuizNums++;
	}
	QuizNums /= 2;
	fclose(pFile);

	quiz = (Quiz*)malloc(sizeof(Quiz) * QuizNums);	//	 ŭ 迭 Ҵ

	ReadFileFix(quiz, "Quiz.txt");

	//	DisplayQuiz(quiz, QuizNums);

	srand((unsigned)time(NULL));

	GamePlay(quiz, QuizNums);

	free(quiz);		//	Ҵ 

	return 0;
}

/*	Ͽ   о quiz迭 ϴ Լ	*/
void ReadFile(Quiz* _pQuiz, char* _pFileName)
{
	int count = 0;
	FILE* pFile = fopen(_pFileName, "r");
	char buf[5];

	while (!feof(pFile))
	{
		fgets(_pQuiz[count].Question, 256, pFile);
		fscanf(pFile, "%d", &_pQuiz[count].Answer);
		fgets(buf, 256, pFile);
		_pQuiz[count].IsUsed = 0;	//	 Ǯ   0 

		count++;
	}
	fclose(pFile);
}

/*	Ͽ   о quiz迭 ϴ Լ	*/
void ReadFileFix(Quiz* _pQuiz, char* _pFileName)
{
	int count = 0;
	FILE* pFile = fopen(_pFileName, "r");
	char buf[5];

	while (!feof(pFile))
	{
		fgets(_pQuiz[count].Question, sizeof(_pQuiz[count].Question) - 1, pFile);

		//	Ű ϴ κ
		{
			int l_len = strlen(_pQuiz[count].Question);

			_pQuiz[count].Question[l_len - 1] = '\0';	//	๮ ڸ  ڸ 
		}

		fscanf(pFile, "%d", &_pQuiz[count].Answer);
		fgets(buf, 256, pFile);

		_pQuiz[count].IsUsed = 0;	//	 Ǯ   0 

		count++;
	}

	fclose(pFile);
}

/*
	 Ͽ ҷ Ͱ quiz迭 Ǿ Ȯϴ Լ,
	   ϴ Լ ߿  ȴ.
*/
void DisplayQuiz(Quiz* _pQuiz, int _quizCount)
{
	for ( int i = 0; i < _quizCount; i++)
	{
		printf(" Q[%d] : %s\n", i + 1, _pQuiz[i].Question);
		printf(" A[%d] : %d\n", i + 1, _pQuiz[i].Answer);
		printf("\n");
	}
}

/*	 Ǫ Լ	*/
void GamePlay(Quiz* _pQuiz, const int _QuizNums)
{	
	int Correct = 0;			//	  
	int Miss = 0;				//	Ʋ  
	int QuizNumber = 0;			//	Ǭ  
	int UserInput;

	//	  Ǯ  ݺ
	while (1)
	{
		int l_randQuizNum = rand() % _QuizNums;	//	Ǯ  

		//	Ǯ  Ǯ ʴ´. ٽ Ǯ  
		if (_pQuiz[l_randQuizNum].IsUsed == 1)
			continue;

		QuizNumber++;
		printf("[%d]. %s\n", QuizNumber, _pQuiz[l_randQuizNum].Question);
		printf(" Է Ͻÿ (1:O  2:X) => ");

		scanf("%d", &UserInput);

		//	Է    ġϸ
		if (UserInput == _pQuiz[l_randQuizNum].Answer)
		{
			printf("Դϴ.\n\n");
			Correct++;
		}

		//	Է    ġ 
		else
		{
			printf("Դϴ.\n\n");
			Miss++;
		}

		_pQuiz[l_randQuizNum].IsUsed = 1;	//	 ǮǷ 1 

		//	  Ǯ Ȯ
		if (_QuizNums == QuizNumber)
			break;
	}
}

